
/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2008 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*******************************************************************************
* $Id: atsapi.h,v 1.2.2.1.2.4 2009/07/03 08:49:23 rfrance Exp $
*******************************************************************************/

/* this include intend to help to integrate the VT generated code into the application.
   to use the generated code as a task stub or task simulation or stimulation
   generate the code as a thread with the entry point as ATL_Start.
   then form your application code, CALL it as START_INSTANCE("A","my_riofile_A.rio")
   to execute the pts script instance A and get the riofilename as "my_riofile_A.rio"
*/
#ifndef _ATSAPI_INCLUDED
#define _ATSAPI_INCLUDED

#ifndef ATS_THREAD_FUNCTION
#define ATS_THREAD_FUNCTION ATL_Start
#define ATS_THREAD_TABLE    ATL_Start_Table
#define ATS_THREAD_TABLELEN ATL_Start_TableLen
#endif

/* ATL_T_THREAD_RETURN can be redefined by a define RTST_THREAD_RETURN xxx  into the Include files or code visible only to the Target Deployment Port */
#ifndef ATL_T_THREAD_RETURN
#define ATL_T_THREAD_RETURN void
#endif

extern int ATS_THREAD_TABLELEN;
extern char * ATS_THREAD_TABLE [];
extern ATL_T_THREAD_RETURN ATS_THREAD_FUNCTION(ATL_PT_ARG arg);

typedef struct {
  char *atl_riofilename;
  char *atl_filters;
  char *atl_instance;
  int   atl_occid;
} ATL_T_ARG, *ATL_PT_ARG;

/* the following macro provide a means to start threads from client code in order to stub client thread */
#define START_INSTANCE(inst,rio) {ATL_T_ARG atl_args; \
			atl_args.atl_riofilename=rio; \
			atl_args.atl_filters=""; \
			atl_args.atl_instance=inst; \
			atl_args.atl_occid=0; \
			ATS_THREAD_FUNCTION(&atl_args);}

#endif /* _ATSAPI_INCLUDED */

